"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.constants = void 0;
var u = __importStar(require("@jsmanifest/utils"));
var ws_1 = __importDefault(require("ws"));
var globby_1 = __importDefault(require("globby"));
var chokidar_1 = __importDefault(require("chokidar"));
var utils_1 = require("./utils");
var c = __importStar(require("./constants"));
exports.constants = c;
var pluginName = 'noodl-webpack-plugin';
var tag = "[" + u.cyan(pluginName) + "]";
var info = function (s1) {
    var s2 = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        s2[_i - 1] = arguments[_i];
    }
    return u.log.apply(u, __spreadArray([tag + " " + s1], s2));
};
var tappedCounter = 0;
var NoodlWebpackPlugin = /** @class */ (function () {
    function NoodlWebpackPlugin(options) {
        this.options = {};
        this.options.config = (options === null || options === void 0 ? void 0 : options.config) || c.DEFAULT_CONFIG;
        this.options.hostname = (options === null || options === void 0 ? void 0 : options.hostname) || c.DEFAULT_HOSTNAME;
        this.options.locale = (options === null || options === void 0 ? void 0 : options.locale) || c.DEFAULT_LOCALE;
        this.options.serverPath = (options === null || options === void 0 ? void 0 : options.serverPath) || c.DEFAULT_SERVER_PATH;
        this.options.serverPort = (options === null || options === void 0 ? void 0 : options.serverPort) || c.DEFAULT_SERVER_PORT;
        this.options.wssPort = (options === null || options === void 0 ? void 0 : options.wssPort) || c.DEFAULT_WSS_PORT;
        this.options.staticPaths = (options === null || options === void 0 ? void 0 : options.staticPaths) || [];
    }
    Object.defineProperty(NoodlWebpackPlugin.prototype, "config", {
        get: function () {
            return this.options.config;
        },
        set: function (config) {
            this.options.config = config;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NoodlWebpackPlugin.prototype, "serverUrl", {
        get: function () {
            return "http://" + this.options.hostname + ":" + this.options.serverPort;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NoodlWebpackPlugin.prototype, "wssUrl", {
        get: function () {
            return "ws://" + this.options.hostname + ":" + this.options.wssPort;
        },
        enumerable: false,
        configurable: true
    });
    NoodlWebpackPlugin.prototype.apply = function (compiler) {
        var _this = this;
        var _a;
        // prettier-ignore
        info("\n\n" + u.white("Entered the plugins \"apply\" lifecycle " + ++tappedCounter + " time(s)") + "\n");
        var settings = this.options;
        info("Config: " + u.green(settings.config));
        info("Server path: " + u.green(settings.serverPath));
        info("Server port: " + u.green(String(settings.serverPort)));
        info("Server url: " + u.green(this.serverUrl));
        info("Websocket port: " + u.green(String(settings.wssPort)));
        u.newline();
        for (var _i = 0, _b = this.options.staticPaths; _i < _b.length; _i++) {
            var obj = _b[_i];
            (_a = this.server) === null || _a === void 0 ? void 0 : _a.get(this.getRoutes(obj.name), obj.fn);
        }
        var getFilePathMetadata = utils_1.createMetadataExtractor('filepath');
        var isAssetPath = function (s) { return /\/assets?/i.test(s); };
        var localFiles = globby_1.default === null || globby_1.default === void 0 ? void 0 : globby_1.default.sync(this.options.serverPath);
        var assets = [];
        var yml = [];
        var other = [];
        if (localFiles.length) {
            info("Processing " + u.magenta(String(localFiles.length)) + " files");
        }
        else {
            info("No local files found in the server dir");
        }
        for (var _c = 0, localFiles_1 = localFiles; _c < localFiles_1.length; _c++) {
            var filepath = localFiles_1[_c];
            // if (fs.statSync(filepath).isFile() && filepath.includes('/assets')) {
            if (isAssetPath(filepath)) {
                assets.push(getFilePathMetadata(filepath));
            }
            else if (utils_1.isYml(filepath)) {
                yml.push(getFilePathMetadata(filepath));
            }
            else {
                other.push(filepath);
            }
        }
        var registerRoute = function (type) {
            var fn = function (obj) {
                var _a, _b;
                var filename = obj.filename, filepath = obj.filepath, group = obj.group;
                !filename.startsWith('/') && (filename = "/" + filename);
                if (type === 'asset') {
                    //
                }
                else {
                    utils_1.isYml(filename) && (filename = filename.replace('.yml', ''));
                    obj.group = 'page';
                }
                info(u.white("Registering " + u.yellow(group) + " pathname: " + u.magenta(filename) + " filepath: " + filepath));
                if (type === 'asset') {
                    (_a = _this.server) === null || _a === void 0 ? void 0 : _a.get([filename, "/assets/" + filename.replace('/', '')], function (req, res) { return res.sendFile(filepath); });
                }
                else {
                    (_b = _this.server) === null || _b === void 0 ? void 0 : _b.get(_this.getRoutes(filename), function (req, res) {
                        res.send(utils_1.loadFile(filepath));
                    });
                }
            };
            return fn;
        };
        var handleAssetRoute = registerRoute('asset');
        var handlePageRoute = registerRoute('page');
        assets.forEach(handleAssetRoute);
        yml.forEach(handlePageRoute);
        this.listen({
            server: this.server,
            wss: (this.wss = new ws_1.default.Server({
                host: this.options.hostname,
                port: Number(this.options.wssPort),
            })),
            watch: (this.watch = chokidar_1.default.watch(utils_1.getFilePath('server/**/*'), {
                cwd: process.cwd(),
                followSymlinks: true,
                ignoreInitial: true,
            })),
        });
    };
    NoodlWebpackPlugin.prototype.getRoutes = function (name) {
        var paths = ["/" + name];
        if (name.includes('.') && !name.endsWith('.')) {
            var ext = utils_1.getExt(name);
            paths.push("/" + name + "." + ext);
            if (ext === 'yml')
                paths.push("/" + name + this.options.locale + "." + ext);
        }
        return paths;
    };
    /**
     * @param { object } options
     * @param { express.Express } options.server
     * @param { WebSocket.Server } options.wss
     * @param { chokidar.FSWatcher } options.watch
     */
    NoodlWebpackPlugin.prototype.listen = function (_a) {
        var _this = this;
        var server = _a.server, wss = _a.wss, watch = _a.watch;
        var comet = '\u2604\uFE0F';
        var croissant = '\uD83D\uDE48';
        var tags = {
            ws: u.cyan('ws'),
            host: "[" + this.options.hostname + "]",
            port: u.green(String(this.options.serverPort)),
            slash: u.cyan('//'),
            config: u.yellow(this.options.config),
            watch: "[" + u.cyan("watch") + "]",
        };
        server === null || server === void 0 ? void 0 : server.listen(this.options.serverPort, function () {
            info("\n\n" + comet + "   Server ready at " + u.cyan("" + _this.serverUrl) + " " +
                ("" + (_this.options.config ? "using config " + tags.config : '')));
            wss === null || wss === void 0 ? void 0 : wss.on('listening', function () {
                return info(croissant + "  " +
                    "WebSocket server is listening at: " +
                    (tags.ws + ":" + tags.slash + " " + tags.host + ":" + tags.port));
            }).on('connection', function (ws, _a) {
                var socket = _a.socket;
                // prettier-ignore
                info("\n" + u.green("Client is connected: " + u.cyan(socket.remoteAddress)));
                ws.on('message', function (message) { return info('Received: %s', message); });
            }).on('close', function () { return info(u.white("WebSocket server has closed")); }).on('error', function (err) { return info(u.red("[" + err.name + "] " + err.message)); });
            function sendMessage(msg) {
                return new Promise(function (resolve, reject) {
                    wss === null || wss === void 0 ? void 0 : wss.clients.forEach(function (client) {
                        client.send(JSON.stringify(msg, null, 2), function (err) {
                            if (err)
                                reject(err);
                            else
                                resolve(undefined);
                        });
                    });
                });
            }
            function getFileName(path) {
                path.includes('/') && (path = path.substring(path.lastIndexOf('/') + 1));
                utils_1.isYml(path) && (path = path.substring(0, path.lastIndexOf('.yml')));
                return path;
            }
            function onWatchEvent(type, fn) {
                function onEvent(path) {
                    return __awaiter(this, void 0, void 0, function () {
                        var args;
                        return __generator(this, function (_a) {
                            args = {
                                // isFile: stats.isFile(),
                                // isFolder: stats.isDirectory(),
                                name: getFileName(path),
                                path: path,
                                // stats,
                            };
                            sendMessage(__assign({ type: type }, args));
                            fn(args);
                            return [2 /*return*/];
                        });
                    });
                }
                return onEvent;
            }
            watch === null || watch === void 0 ? void 0 : watch.on('ready', function () {
                info(tags.watch + " Watching for file changes at " + u.magenta(_this.options.serverPath));
                sendMessage({ type: c.WATCHING_FILES });
            }).on('change', onWatchEvent(c.FILE_CHANGED, function (args) {
                return info(tags.watch + " file changed", args.path);
            })).on('add', onWatchEvent(c.FILE_ADDED, function (args) {
                var _a;
                info(tags.watch + " file added", args.path);
                if (utils_1.isYml(args.path)) {
                    var filepath_1 = args.path;
                    var filename = filepath_1;
                    !filename.startsWith('/') && (filename = "/" + filename);
                    utils_1.isYml(filename) && (filename = filename.replace('.yml', ''));
                    if (((_a = filename.split('/')) === null || _a === void 0 ? void 0 : _a.length) > 2) {
                        filename = filename.substring(filename.lastIndexOf('/'));
                    }
                    info(u.white("Added new route: " + u.magenta(filename)));
                    var routes = [filename, filename + ".yml", filename + "_en.yml"];
                    server.get(routes, function (req, res) { return res.send(utils_1.loadFile(filepath_1)); });
                }
            })).on('addDir', onWatchEvent(c.FOLDER_ADDED, function (args) {
                return info(tags.watch + " folder added", args.path);
            })).on('unlink', onWatchEvent(c.FILE_REMOVED, function (args) {
                return info(tags.watch + " file was removed", args.path);
            })).on('unlinkDir', onWatchEvent(c.FOLDER_REMOVED, function (args) {
                return info(tags.watch + " folder was removed", args.path);
            })).on('error', function (err) {
                info(tags.watch + " error", err);
                sendMessage({ type: c.WATCH_ERROR, error: err });
            });
        });
    };
    NoodlWebpackPlugin.pluginName = pluginName;
    return NoodlWebpackPlugin;
}());
exports.default = NoodlWebpackPlugin;
//# sourceMappingURL=noodl-webpack-plugin.js.map